// boot.c

#include "boot.h"
#include "image-header.h"

// http://stackoverflow.com/questions/14134245/iso-c-void-and-function-pointers
// void (*syslib) (int);
//    * (void **) (&syslib) = *image->crt0;


int
main (int reset_flags)
{
   crt0_type     *syslib;
   image_struct  *image;

   uart_init (1, 115200);
   printf ("\nboot: ");
   image = find_syslib ();
   if (image == NULL) {
      printf ("syslib not found\n");
   } else {
      printf ("%p\n\n", (void *)image);
      syslib = *image->crt0;
      syslib (reset_flags);
   }
   while (1);
}

