// uart1.c

#include <stddef.h>
#include "F205/rcc.h"
#include "F205/uart.h"

#if 0
int
getchar (int timeout)
{
   int            tmp;
   stdio_struct  *up = current->stdio;

   tmp = up->rxbuf[up->get];
   if (tmp == 0) {
      sleep_ms (timeout);
      tmp = up->rxbuf[up->get];
      if (tmp == 0) {
         return 0; // time-out
      }
   }
   up->rxbuf[up->get] = '\0';
   up->get += 1;
   if (up->get >= UART_RX_BUFSIZE) {
      up->get = 0;
   }
   return tmp;
}


static void __attribute__ ((aligned (16)))
uart_isr (stdio_struct *up, uint32_t c1)
{
   int  tmp;

   if (c1 == CC_ESC) {
      up->esc_state = 1;
      return;
   }
   switch (up->esc_state) {
   case 0:
      break;
   case 1:
      if (c1 == '[' || c1 == 'O') {
         up->esc_state = 2;
      } else {
         up->esc_state = 0;
      }
      return;
   case 2:
      if ((c1 >> 4) == 3) { return; }
      up->esc_state = 0;
      c1 += 128;
      break;
   }

   tmp = up->put + 1;
   if (tmp >= UART_RX_BUFSIZE) {
      tmp = 0;
   }
   if (up->rxbuf[tmp] == 0) {
      up->rxbuf[up->put] = c1;
      up->put = tmp;
      switch (c1) {
      case 'A':
         mode_switch = MODE_SWITCH_A;
         break;
      case 'B':
         mode_switch = MODE_SWITCH_B;
         break;
      default:
         break;
      }
      task_wakeup_sys (up->pid);
   }
   return;
}


void __attribute__ ((aligned (16)))
uart1_isr (void)
{
   uint32_t  c1;

   c1 = UART1->DR & 255;
   if (c1 == 0 || c1 >= 128) { return; }

   uart_isr (up1, c1);
   return;
}
#endif


int
putchar1 (int c1)
{
   if (c1 == '\n') {
      putchar1 ('\r');
   }
   while (UART1->SR_TXE == 0) {  }
   UART1->DR = c1;
   return c1;
}


int
putchar (int c1)
{
   return putchar1 (c1);
}


int
puts1 (const char *text)
{
   while (*text) {
      putchar1 (*text++);
   }
   putchar1 ('\n');
   return 0;
}

#if 0
int
dprintf (const char *fmt, ...)
{
   va_list  ap;

   va_start (ap, fmt);
   return vprintf (fmt, ap);
   va_end (ap);
}
#endif

void
uart_init (int channel, int baud)
{
   uart_struct  *uart;
   int           br_clock;

   RCC->APB2RSTR |= (1 << APB2_USART1);
   uart = UART1;
   br_clock = 16000000;
   RCC->APB2RSTR &= ~ (1 << APB2_USART1);

// br_clock ist genau genommen = (clocks->apbx / 16) * 16
// wegen 16 Clocks/Bit und 4 Bit fractional baud rate
   uart->BRR = (br_clock + baud / 2) / baud;

   uart->CR2_STOP2 = 1;
   if (channel == 1) {
      uart->CR1_M   = 1;
      uart->CR1_PCE = 1;
   }
   uart->CR1_TE  = 1;
   uart->CR1_RE  = 1;
   uart->CR1_UE = 1;
   return;
}

