// crt1.c

#include "crt1.h"

extern int  data_start; // initialisierte statische & globale Daten im RAM
extern int  data_end;   // Ende derselben
extern int  text_end;   // die initialen Werte dazu stehen im Flash
                        //   direkt im Anschluss an das Programm
extern int  bss_start;  // mit 0 initialisierte statische & globale Daten
extern int  bss_end;    // Ende des Datenbereichs
                        // (diese 5 werden im Linker Script definiert)

int
crt1 (int arg)
{
   int  status, *flash, *ram;

//  RAM Initialisierung
//  Die dauert zwar ziemlich lange, aber in der Zwischenzeit kann sich die
//  Betriebsspannung stabilisieren. Die Ausgangspins sind ja schon aktiv.

   for (flash = &text_end, ram = &data_start; ram < &data_end; /* */) {
      *ram++ = *flash++;
   }
   for (ram = &bss_start; ram < &bss_end; ram++) {
      *ram = 0;
   }

//  Hier ist der Process Stack und -Pointer schon initialisiert,
//  dies ist ja ein normales Programm. Andernfalls wrde man hier
//  den Stack mit 0 oder einem Bitmuster initialisieren.

//  Programmstart

   status = main (arg);

//  Programmende; sollte eigentlich nicht vorkommen
//
//  Hier sollte man etwas sinnvolleres als eine einfache Endlosschleife
//  einbauen. Man koennte wenigstens eine LED blinken lassen oder eine
//  Meldung ausgeben. Evt. gibt es auch andere Stellen im Programm,
//  wo man nur noch aufgeben kann. Dafuer koennte man eine gemeinsame
//  exit-/crash-/finish-/restart-/oder-so-Funktion gebrauchen.

   return status;
}

