// crc.h
#pragma once
#include <stdint.h>

typedef volatile struct /* crc_struct */ {  // word access
// 00 Data register (CRC_DR)
  uint32_t  DR;
// 04 Independent data register (CRC_IDR)
  uint32_t  IDR;
// 08 Control register (CRC_CR)
  uint32_t  CR_RESET    :  1;
  uint32_t              : 31;
} crc_struct;

_Static_assert (sizeof(crc_struct) == 12, " crc_struct: bad size");

static crc_struct * const CRC = (crc_struct *)0x40023000;

