// exti.h
#pragma once
#include <stdint.h>

static const int  EXTI_PVD        = 1 << 16;
static const int  EXTI_RTC_ALARM  = 1 << 17;
static const int  EXTI_USB_OTG_FS = 1 << 18;
static const int  EXTI_ETH        = 1 << 19;
static const int  EXTI_USB_OTG_HS = 1 << 20;
static const int  EXTI_RTC_TAMPER = 1 << 21;
static const int  EXTI_RTC_WAKE   = 1 << 22;

typedef volatile struct /* exti_struct */ {  // word access; 23 event lines
// 00 Interrupt mask register (EXTI_IMR)
  uint32_t  IMR;
// 04 Event mask register (EXTI_EMR)
  uint32_t  EMR;
// 08 Rising trigger selection register (EXTI_RTSR)
  uint32_t  RTSR;
// 0C Falling trigger selection register (EXTI_FTSR)
  uint32_t  FTSR;
// 10 Software interrupt event register (EXTI_SWIER)
  uint32_t  SWIER;
// 14 Pending register (EXTI_PR)
  uint32_t  PR;
} exti_struct;

_Static_assert (sizeof(exti_struct) == 24, " exti_struct: bad size");

static exti_struct * const EXTI = (exti_struct *)0x40013C00;

