// gpio.h
#pragma once
#include <stdint.h>

typedef enum moder_enum {
  MODE_INPUT,
  MODE_OUTPUT,
  MODE_AF,
  MODE_ANALOG
} moder_enum;

typedef enum otyper_enum {
  TYPE_pp,      // default, push pull
  TYPE_OD       // open drain
} otyper_enum;

typedef enum ospeedr_enum {
  SPEED_0,      // default, slow
  SPEED_MEDIUM,
  SPEED_FAST,
  SPEED_HIGH
} ospeedr_enum;

typedef enum pupdr_enum {
  PULL_0,       // default, no pull
  PULL_UP,
  PULL_DOWN
} pupdr_enum;

typedef enum odr_enum {
  LOW,          // default, 0
  HIGH
} odr_enum;

#if 0
typedef enum af_pc9_enum {
   AF_PC9_MCO2         = 0 | 0x200,
   AF_PC9_TIM3_CH4     = 2 | 0x200,
   AF_PC9_TIM8_CH4     = 3 | 0x200,
   AF_PC9_I2C3_SDA     = 4 | 0x200,
   AF_PC9_I2S2_CKIN    = 5 | 0x200,
   AF_PC9_I2S3_CKIN    = 6 | 0x200,
   AF_PC9_INPUT        = 0 | 0x000 | OPEN_DRAIN * 0x400 | HIGH * 0x800,
   AF_PC9_OUTPUT       = 0 | 0x100,
   AF_PC9_ANALOG       = 0 | 0x300,
} pc9_enum;

static const int AF_MCO1_PA8         = 0;
static const int AF_MCO2_PC9         = 0;
static const int AF_RTC_50Hz_PB15    = 0;
static const int AF_SWCLK_PA14       = 0;
static const int AF_SWDIO_PA13       = 0;
static const int AF_TRACESWO_PB3     = 0;

static const int AF_CAN1_RX_PB8      = 9;
static const int AF_CAN1_RX_PC11     = 9;
static const int AF_CAN1_TX_PB9      = 9;
static const int AF_CAN1_TX_PC12     = 9;

static const int AF_CAN2_RX_PB12     = 9;
static const int AF_CAN2_RX_PB5      = 9;
static const int AF_CAN2_TX_PB13     = 9;
static const int AF_CAN2_TX_PB6      = 9;

static const int AF_I2C1_SCL_PB6     = 4;
static const int AF_I2C1_SCL_PB8     = 4;
static const int AF_I2C1_SDA_PB7     = 4;
static const int AF_I2C1_SDA_PB9     = 4;
static const int AF_I2C1_SMBA_PB5    = 4;

static const int AF_I2C2_SCL_PB10    = 4;
static const int AF_I2C2_SDA_PB11    = 4;
static const int AF_I2C2_SMBA_PB12   = 4;

static const int AF_I2C3_SCL_PA8     = 4;
static const int AF_I2C3_SDA_PC9     = 4;
static const int AF_I2C3_SMBA_PA9    = 4;

static const int AF_I2S2_CKIN_PC9    = 5;
static const int AF_I2S2_MCK_PC6     = 5;
static const int AF_I2S2_SCK_PB10    = 5;
static const int AF_I2S2_SCK_PB13    = 5;
static const int AF_I2S2_SD_PB15     = 5;
static const int AF_I2S2_WS_PB12     = 5;
static const int AF_I2S2_WS_PB9      = 5;

static const int AF_I2S3_CKIN_PC9    = 6;
static const int AF_I2S3_MCK_PC7     = 6;
static const int AF_I2S3_SCK_PB3     = 6;
static const int AF_I2S3_SCK_PC10    = 6;
static const int AF_I2S3_SD_PB5      = 6;
static const int AF_I2S3_SD_PC12     = 6;
static const int AF_I2S3_WS_PA15     = 6;
static const int AF_I2S3_WS_PA4      = 6;

static const int AF_SPI1_MISO_PA6    = 5;
static const int AF_SPI1_MISO_PB4    = 5;
static const int AF_SPI1_MOSI_PA7    = 5;
static const int AF_SPI1_MOSI_PB5    = 5;
static const int AF_SPI1_NSS_PA15    = 5;
static const int AF_SPI1_NSS_PA4     = 5;
static const int AF_SPI1_SCK_PA5     = 5;
static const int AF_SPI1_SCK_PB3     = 5;

static const int AF_SPI2_MISO_PB14   = 5;
static const int AF_SPI2_MOSI_PB15   = 5;
static const int AF_SPI2_MOSI_PC3    = 5;
static const int AF_SPI2_NSS_PB12    = 5;
static const int AF_SPI2_NSS_PB9     = 5;
static const int AF_SPI2_SCK_PB10    = 5;
static const int AF_SPI2_SCK_PB13    = 5;

static const int AF_SPI3_MISO_PB4    = 6;
static const int AF_SPI3_MISO_PC11   = 6;
static const int AF_SPI3_MOSI_PB5    = 6;
static const int AF_SPI3_MOSI_PC12   = 6;
static const int AF_SPI3_NSS_PA15    = 6;
static const int AF_SPI3_NSS_PA4     = 6;
static const int AF_SPI3_SCK_PB3     = 6;
static const int AF_SPI3_SCK_PC10    = 6;

static const int AF_TIM1_BKIN_PA6    = 1;
static const int AF_TIM1_BKIN_PB12   = 1;
static const int AF_TIM1_CH1N_PA7    = 1;
static const int AF_TIM1_CH1N_PB13   = 1;
static const int AF_TIM1_CH1_PA8     = 1;
static const int AF_TIM1_CH2N_PB0    = 1;
static const int AF_TIM1_CH2N_PB14   = 1;
static const int AF_TIM1_CH2_PA9     = 1;
static const int AF_TIM1_CH3N_PB1    = 1;
static const int AF_TIM1_CH3N_PB15   = 1;
static const int AF_TIM1_CH3_PA10    = 1;
static const int AF_TIM1_CH4_PA11    = 1;
static const int AF_TIM1_ETR_PA12    = 1;

static const int AF_TIM2_CH1_ETR_PA0 = 1;
static const int AF_TIM2_CH1_ETR_PA5 = 1;
static const int AF_TIM2_CH1_PA15    = 1;
static const int AF_TIM2_CH2_PA1     = 1;
static const int AF_TIM2_CH2_PB3     = 1;
static const int AF_TIM2_CH3_PA2     = 1;
static const int AF_TIM2_CH3_PB10    = 1;
static const int AF_TIM2_CH4_PA3     = 1;
static const int AF_TIM2_CH4_PB11    = 1;
static const int AF_TIM2_ETR_PA15    = 1;

static const int AF_TIM3_CH1_PA6     = 2;
static const int AF_TIM3_CH1_PB4     = 2;
static const int AF_TIM3_CH1_PC6     = 2;
static const int AF_TIM3_CH2_PA7     = 2;
static const int AF_TIM3_CH2_PB5     = 2;
static const int AF_TIM3_CH2_PC7     = 2;
static const int AF_TIM3_CH3_PB0     = 2;
static const int AF_TIM3_CH3_PC8     = 2;
static const int AF_TIM3_CH4_PB1     = 2;
static const int AF_TIM3_CH4_PC9     = 2;
static const int AF_TIM3_ETR_PD2     = 2;

static const int AF_TIM4_CH1_PB6     = 2;
static const int AF_TIM4_CH2_PB7     = 2;
static const int AF_TIM4_CH3_PB8     = 2;
static const int AF_TIM4_CH4_PB9     = 2;

static const int AF_TIM5_CH1_PA0     = 2;
static const int AF_TIM5_CH2_PA1     = 2;
static const int AF_TIM5_CH3_PA2     = 2;
static const int AF_TIM5_CH4_PA3     = 2;

static const int AF_TIM8_BKIN_PA6    = 3;
static const int AF_TIM8_CH1N_PA5    = 3;
static const int AF_TIM8_CH1_PC6     = 3;
static const int AF_TIM8_CH2N_PB0    = 3;
static const int AF_TIM8_CH2N_PB14   = 3;
static const int AF_TIM8_CH2_PC7     = 3;
static const int AF_TIM8_CH3N_PB1    = 3;
static const int AF_TIM8_CH3N_PB15   = 3;
static const int AF_TIM8_CH3_PC8     = 3;
static const int AF_TIM8_CH4_PC9     = 3;
static const int AF_TIM8_ETR_PA0     = 3;

static const int AF_TIM9_CH1_PA2     = 3;
static const int AF_TIM9_CH2_PA3     = 3;

static const int AF_TIM10_CH1_PB8    = 3;

static const int AF_TIM11_CH1_PB9    = 3;

static const int AF_TIM12_CH1_PB14   = 9;
static const int AF_TIM12_CH2_PB15   = 9;

static const int AF_TIM13_CH1_PC6    = 9;

static const int AF_TIM14_CH1_PC7    = 9;

static const int AF_USART1_CK_PA8    = 7;
static const int AF_USART1_CTS_PA11  = 7;
static const int AF_USART1_RTS_PA12  = 7;
static const int AF_USART1_RX_PA10   = 7;
static const int AF_USART1_RX_PB7    = 7;
static const int AF_USART1_TX_PA9    = 7;
static const int AF_USART1_TX_PB6    = 7;

static const int AF_USART2_CK_PA4    = 7;
static const int AF_USART2_CTS_PA0   = 7;
static const int AF_USART2_RTS_PA1   = 7;
static const int AF_USART2_RX_PA3    = 7;
static const int AF_USART2_TX_PA2    = 7;

static const int AF_USART3_CK_PB12   = 7;
static const int AF_USART3_CK_PC12   = 7;
static const int AF_USART3_CTS_PB13  = 7;
static const int AF_USART3_RTS_PB14  = 7;
static const int AF_USART3_RX_PB11   = 7;
static const int AF_USART3_RX_PC11   = 7;
static const int AF_USART3_TX_PB10   = 7;
static const int AF_USART3_TX_PC10   = 7;

static const int AF_UART4_RX_PA1     = 8;
static const int AF_UART4_RX_PC11    = 8;
static const int AF_UART4_TX_PA0     = 8;
static const int AF_UART4_TX_PC10    = 8;

static const int AF_UART5_RX_PD2     = 8;
static const int AF_UART5_TX_PC12    = 8;

static const int AF_USART6_CK_PC8    = 8;
static const int AF_USART6_RX_PC7    = 8;
static const int AF_USART6_TX_PC6    = 8;


static const int AF_CAN1_RX_PD0      = 9;
static const int AF_CAN1_TX_PD1      = 9;
static const int AF_USART2_CTS_PD3   = 7;
static const int AF_USART2_RTS_PD4   = 7;
static const int AF_USART2_TX_PD5    = 7;
static const int AF_USART2_RX_PD6    = 7;
static const int AF_USART2_CK_PD7    = 7;
static const int AF_USART3_TX_PD8    = 7;
static const int AF_USART3_RX_PD9    = 7;
static const int AF_USART3_CK_PD10   = 7;
static const int AF_USART3_CTS_PD11  = 7;
static const int AF_USART3_RTS_PD12  = 7;
static const int AF_TIM4_CH1_PD12    = 2;
static const int AF_TIM4_CH2_PD13    = 2;
static const int AF_TIM4_CH3_PD14    = 2;
static const int AF_TIM4_CH4_PD15    = 2;
static const int AF_TIM4_ETR_PE0     = 2;
static const int AF_TIM9_CH1_PE5     = 3;
static const int AF_TIM9_CH2_PE6     = 3;
static const int AF_TIM1_ETR_PE7     = 1;
static const int AF_TIM1_CH1N_PE8    = 1;
static const int AF_TIM1_CH1_PE9     = 1;
static const int AF_TIM1_CH2N_PE10   = 1;
static const int AF_TIM1_CH2_PE11    = 1;
static const int AF_TIM1_CH3N_PE12   = 1;
static const int AF_TIM1_CH3_PE13    = 1;
static const int AF_TIM1_CH4_PE14    = 1;
static const int AF_TIM1_BKIN_PE15   = 1;
// to be continued
#endif


typedef volatile struct /* gpio_struct */ {  // byte/half/word access
// 00 Port mode register (GPIOx_MODER) (x = A..I)
  union {
    uint32_t  MODER;
    struct {
      uint32_t  MODER0    :  2;
      uint32_t  MODER1    :  2;
      uint32_t  MODER2    :  2;
      uint32_t  MODER3    :  2;
      uint32_t  MODER4    :  2;
      uint32_t  MODER5    :  2;
      uint32_t  MODER6    :  2;
      uint32_t  MODER7    :  2;
      uint32_t  MODER8    :  2;
      uint32_t  MODER9    :  2;
      uint32_t  MODER10   :  2;
      uint32_t  MODER11   :  2;
      uint32_t  MODER12   :  2;
      uint32_t  MODER13   :  2;
      uint32_t  MODER14   :  2;
      uint32_t  MODER15   :  2;
    };
  };
// 04 Port output type register (GPIOx_OTYPER)
  union {
    uint32_t  OTYPER;
    struct {
      uint32_t  OT0       :  1;
      uint32_t  OT1       :  1;
      uint32_t  OT2       :  1;
      uint32_t  OT3       :  1;
      uint32_t  OT4       :  1;
      uint32_t  OT5       :  1;
      uint32_t  OT6       :  1;
      uint32_t  OT7       :  1;
      uint32_t  OT8       :  1;
      uint32_t  OT9       :  1;
      uint32_t  OT10      :  1;
      uint32_t  OT11      :  1;
      uint32_t  OT12      :  1;
      uint32_t  OT13      :  1;
      uint32_t  OT14      :  1;
      uint32_t  OT15      :  1;
      uint32_t            : 16;
    };
  };
// 08 Port output speed register (GPIOx_OSPEEDR)
  union {
    uint32_t  OSPEEDR;
    struct {
      uint32_t  OSPEEDR0  :  2;
      uint32_t  OSPEEDR1  :  2;
      uint32_t  OSPEEDR2  :  2;
      uint32_t  OSPEEDR3  :  2;
      uint32_t  OSPEEDR4  :  2;
      uint32_t  OSPEEDR5  :  2;
      uint32_t  OSPEEDR6  :  2;
      uint32_t  OSPEEDR7  :  2;
      uint32_t  OSPEEDR8  :  2;
      uint32_t  OSPEEDR9  :  2;
      uint32_t  OSPEEDR10 :  2;
      uint32_t  OSPEEDR11 :  2;
      uint32_t  OSPEEDR12 :  2;
      uint32_t  OSPEEDR13 :  2;
      uint32_t  OSPEEDR14 :  2;
      uint32_t  OSPEEDR15 :  2;
    };
  };
// 0C Port pull-up/pull-down register (GPIOx_PUPDR)
  union {
    uint32_t  PUPDR;
    struct {
      uint32_t  PUPDR0    :  2;
      uint32_t  PUPDR1    :  2;
      uint32_t  PUPDR2    :  2;
      uint32_t  PUPDR3    :  2;
      uint32_t  PUPDR4    :  2;
      uint32_t  PUPDR5    :  2;
      uint32_t  PUPDR6    :  2;
      uint32_t  PUPDR7    :  2;
      uint32_t  PUPDR8    :  2;
      uint32_t  PUPDR9    :  2;
      uint32_t  PUPDR10   :  2;
      uint32_t  PUPDR11   :  2;
      uint32_t  PUPDR12   :  2;
      uint32_t  PUPDR13   :  2;
      uint32_t  PUPDR14   :  2;
      uint32_t  PUPDR15   :  2;
    };
  };
// 10 Port input data register (GPIOx_IDR)
  uint32_t  IDR;
// 14 Port output data register (GPIOx_ODR)
  uint32_t  ODR;
// 18 Port bit set/reset register (GPIOx_BSRR)
  union {
    uint32_t  BSRR;
    struct {
      uint16_t  BSR;
      uint16_t  BRR;
    };
    struct {
      uint8_t   BSR_00_07;
      uint8_t   BSR_08_15;
      uint8_t   BRR_00_07;
      uint8_t   BRR_08_15;
    };
    struct {
      uint32_t  BS0       :  1;
      uint32_t  BS1       :  1;
      uint32_t  BS2       :  1;
      uint32_t  BS3       :  1;
      uint32_t  BS4       :  1;
      uint32_t  BS5       :  1;
      uint32_t  BS6       :  1;
      uint32_t  BS7       :  1;
      uint32_t  BS8       :  1;
      uint32_t  BS9       :  1;
      uint32_t  BS10      :  1;
      uint32_t  BS11      :  1;
      uint32_t  BS12      :  1;
      uint32_t  BS13      :  1;
      uint32_t  BS14      :  1;
      uint32_t  BS15      :  1;
      uint32_t  BR0       :  1;
      uint32_t  BR1       :  1;
      uint32_t  BR2       :  1;
      uint32_t  BR3       :  1;
      uint32_t  BR4       :  1;
      uint32_t  BR5       :  1;
      uint32_t  BR6       :  1;
      uint32_t  BR7       :  1;
      uint32_t  BR8       :  1;
      uint32_t  BR9       :  1;
      uint32_t  BR10      :  1;
      uint32_t  BR11      :  1;
      uint32_t  BR12      :  1;
      uint32_t  BR13      :  1;
      uint32_t  BR14      :  1;
      uint32_t  BR15      :  1;
    };
  };
// 1C Port configuration lock register (GPIOx_LCKR)
  uint32_t  LCK0          :  1;
  uint32_t  LCK1          :  1;
  uint32_t  LCK2          :  1;
  uint32_t  LCK3          :  1;
  uint32_t  LCK4          :  1;
  uint32_t  LCK5          :  1;
  uint32_t  LCK6          :  1;
  uint32_t  LCK7          :  1;
  uint32_t  LCK8          :  1;
  uint32_t  LCK9          :  1;
  uint32_t  LCK10         :  1;
  uint32_t  LCK11         :  1;
  uint32_t  LCK12         :  1;
  uint32_t  LCK13         :  1;
  uint32_t  LCK14         :  1;
  uint32_t  LCK15         :  1;
  uint32_t  LCKK          :  1;
  uint32_t                : 15;
// 20 Alternate function low register (GPIOx_AFRL)
  union {
    uint32_t  AFRL;
    struct {
      uint32_t  AFRL0     :  4;
      uint32_t  AFRL1     :  4;
      uint32_t  AFRL2     :  4;
      uint32_t  AFRL3     :  4;
      uint32_t  AFRL4     :  4;
      uint32_t  AFRL5     :  4;
      uint32_t  AFRL6     :  4;
      uint32_t  AFRL7     :  4;
    };
  };
// 24 Alternate function high register (GPIOx_AFRH)
  union {
    uint32_t  AFRH;
    struct {
      uint32_t  AFRH8     :  4;
      uint32_t  AFRH9     :  4;
      uint32_t  AFRH10    :  4;
      uint32_t  AFRH11    :  4;
      uint32_t  AFRH12    :  4;
      uint32_t  AFRH13    :  4;
      uint32_t  AFRH14    :  4;
      uint32_t  AFRH15    :  4;
    };
  };
  uint8_t  fill_to_0x400[0x400 - 40];
} gpio_struct;

_Static_assert (sizeof(gpio_struct) == 0x400, " gpio_struct: bad size");

static gpio_struct * const GPIOI = (gpio_struct *)0x40022000;
static gpio_struct * const GPIOH = (gpio_struct *)0x40021C00;
static gpio_struct * const GPIOG = (gpio_struct *)0x40021800;
static gpio_struct * const GPIOF = (gpio_struct *)0x40021400;
static gpio_struct * const GPIOE = (gpio_struct *)0x40021000;
static gpio_struct * const GPIOD = (gpio_struct *)0x40020C00;
static gpio_struct * const GPIOC = (gpio_struct *)0x40020800;
static gpio_struct * const GPIOB = (gpio_struct *)0x40020400;
static gpio_struct * const GPIOA = (gpio_struct *)0x40020000;

