// undocumented.h -- ntzliche Bits, die ARM und ST geheim halten

// aus den unendlichen Weiten des Internet...

/* Note: This was originally posted on 11th December 2009 at http://forums.arm.com

Hi Krish,

I few things you need to do:
1. Define the registers as "volatile", and "unsigned"

2. Enable TRCENA bit in DEMCR (0xE000EDFC, bit 24) before using DWT

3. You should use DWT's Cycle Count Register (0xE0001004) for timing measurement.
The CPI counter is only 8-bit, and need to have trace support to detect the number of time it overflow.
While the DWT Cycle Count Register is 32-bit.

4. You need to enable the Cycle Count counter.

So based on the code you have prepared, it can be modified to:
int count = 0;
volatile unsigned int *DWT_CYCCNT = (int *)0xE0001004; //address of the register
volatile unsigned int *DWT_CONTROL = (int *)0xE0001000; //address of the register
volatile unsigned int *SCB_DEMCR = (int *)0xE000EDFC; //address of the register

*SCB_DEMCR = *SCB_DEMCR | 0x01000000;
*DWT_CYCCNT = 0; // reset the counter
*DWT_CONTROL = *DWT_CONTROL | 1 ; // enable the counter
.......
......
count = *DWT_CYCCNT;
*/
#pragma once
#include <stdint.h>

typedef volatile struct /* dwt_struct */ {
// 00 Control
  uint32_t  CYCCNT_EN   :  1;
  uint32_t              : 31;
// 04 Cycle Counter
  uint32_t  CYCCNT;
} dwt_struct;

static dwt_struct * const DWT = (dwt_struct *)0xE0001000;


typedef volatile struct /* debug_struct */ {
// 00
  uint32_t  unknown_0;
// 04
  uint32_t  unknown_4;
// 08
  uint32_t  unknown_8;
// 0C  DEMCR
  uint32_t              : 24;
  uint32_t  TRCENA      :  1;
  uint32_t              :  7;
} debug_struct;

static debug_struct * const DEBUG = (debug_struct *)0xE000EDF0;

// DFSR Bits (DFSR in scb_struct @ 0xE000ED30)

static const int  DFSR_HALT   =  1;
static const int  DFSR_BREAK  =  2;
static const int  DFSR_WATCH  =  4;
static const int  DFSR_VECTOR =  8;
static const int  DFSR_EXTERN = 16;

