// PCA9538.h
#pragma once

// I2C I/O-Port PCA9538, Reset on PB2

static const int I2C_PCA9538 = 112; // i2c Adressen haben 7 Bit und enthalten
                                    // kein Read/Write-Bit. Es gibt keine
                                    // getrennten Lese- und Schreib-Adressen.
                                    // Die beste Schreibweise wre 0b1110000,
                                    // aber das erlaubt C11 nicht.

typedef enum PCA9538_register_enum {
  PCA9538_IDR = 0,  // Input data
  PCA9538_ODR = 1,  // Output data   !! reset value = 0xFF !!
  PCA9538_INV = 2,  // Polarity inversion
  PCA9538_DDR = 3   // Data direction
} PCA9538_register_enum;

