// exec.h
#pragma once
#include <stdint.h>
#include "image-header.h"
#include "syslib.h"

static const int  ADC_FILTER = 32;  // 2, 4, 8, ... 256, 512 -- sonst overflow

void   board_reboot (void);
void   board_shutdown (void);
void   crash (void) __attribute__((noreturn));
int    crc_check (image_struct *region);
int    do_get_taskinfo (int pid, taskinfo_struct *info);
void   do_syslog (int event_id, int p32, int p16);
void   do_uart_init (int uart, int baud, stdio_struct *buf);
int    find_images (task_struct tcb[], int tcb_size);
void   gpio_init (void);
void   main (int reset_flags);
void   mpu_reset (void);
int    mpu_set_region (int n, const uint32_t *sp, const uint32_t *ep, int ap);
void   syslog_init (void);
void   task_wakeup_sys (int pid);
void   trace_show (void);
int    tz_init (void);

