// temperature.h
#pragma once

// Temperatur Bits, allgemein sind Temperaturen int32_t;
// uint16_t knnte auch reichen, auch fr TEGs und Abgas, nicht fr Flammrohr

static const int T_F_MUL = 50;  // diese sollen fr die Anzeige durch 10
static const int T_C_MUL = 90;  // teilbar sein. Sie sollen gross genug sein,
                                // dass 0.1K darstellbar und grer
                                // als TEMP_OPEN ist
typedef enum temperature_enum {
   T_UNDEF,                     // keine Daten
   T_SHORT,                     // Kurzschlus, gemessen
   T_OPEN,                      // Offen, gemessen
   T_05K      =   90 / 2,       // 0.5 Kelvin
   T_1K       =   1 * 90,
   T_2K       =   2 * 90,
   T_3K       =   3 * 90,
   T_5K       =   5 * 90,
   T_17K      =  17 * 90,
// TEMP_200K  =    18000,       // -99.67F = -73.15C
//            =    20970,       // -40.27F = -40.15C
   T_ABSMIN   =    20984,       // -40.00F = -40.00C
   T_0F       =    22984,       // 459.67 * 50 = -17.7778C
   T_0C       =    24584,       // 273.15 * 90  (Fehler < 0.006K)
   T_25C      =  25 * 90 + T_0C,
   T_40C      =  40 * 90 + T_0C,
   T_75C      =  75 * 90 + T_0C,
   T_ABSMAX   =  90 * 90 + T_0C,
//              32767           //  90.9C
//              33578           //   100C = 212F
//              65535           //   455C = 851F = 728.2K
//             301784           // Wasserstoff/Sauerstoff-Flamme <= 3080C
} temperature_enum;

//static inline int C_(int T) { return T * C_MUL + TEMP_0C; }
//static inline int F_(int T) { return T * F_MUL + TEMP_0F; }
//static inline int K_(int T) { return T * C_MUL; }

int  print_temp (int unit, int kelvins);

