// addr-to-line.c

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "fail.h"


int
main (int argc, char *argv[])
{
   FILE    *mem;
   char    *orig, *leng, *prog, *dots, *s1, buf[132], cmd[132];
   uint32_t origin, addr;
   int      arg, length;

   if (access ("memory.ld", R_OK) == 0) {
      mem = fail_or_open_ro ("memory.ld");
      dots = ".";
   } else {
      mem = fail_or_open_ro ("../memory.ld");
      dots = "..";
   }
   for (arg = 1; arg < argc; arg++) {
      addr = strtol (argv[arg], NULL, 16);
      while (fgets (buf, sizeof buf, mem)) {
         orig = strstr (buf, "ORIGIN");
         leng = strstr (buf, "LENGTH");
         prog = strstr (buf, "flash_");
         if (orig == NULL || leng == NULL || prog == NULL) { continue; }
         prog += strlen ("flash_");
         orig  = strchr (orig, '=');
         leng  = strchr (leng, '=');
         s1    = strchr (prog, ' ');
         if (orig == NULL || leng == NULL || s1 == NULL) { continue; }
         *s1 = '\0';
         origin = strtol (orig + 1, NULL, 0);
         length = strtol (leng + 1, &s1, 0);
         if (*s1 == 'K') {
            length *= 1024;
         }
         if (addr < origin || addr > origin + length) { continue; }
         printf ("%s: ", prog);
         fflush (stdout);
         snprintf (cmd, sizeof cmd,
                   "arm-none-eabi-addr2line -p -C -f -s -i "
                   "-e %s/%s/BUILD/%s.elf %x", dots, prog, prog, addr);
         system (cmd);
      }
      rewind (mem);
   }
   return 0;
}

