// beep-calc.c

#include <ctype.h>
#include <math.h>
#include <stdio.h>
#include <string.h>

static char *note[] = {
   "h", "ais", "a", "gis", "g", "fis", "f", "e", "dis", "d", "cis", "c",
   "h", "b",   "a", "as",  "g", "ges", "f", "e", "es",  "d", "des", "c"
};


void
print_note (int great, char *text, int octave, double freq)
{
   char *c1;
   int   blank;

   printf ("   note_");
   if (great) {
      for (c1 = text; *c1; c1++) {
         putchar (toupper (*c1));
      }
   } else {
      printf ("%s", text);
   }
   if (octave == 0) {
      printf (" ");
   } else {
      printf ("%d", octave);
   }
   blank = 4 - strlen (text);
   printf ("%*.*s", blank, blank, " ");
   printf ("= %7.0f,\n", freq);
   return;
}


int
main (void)
{
   double f1, mult;
   int    i1, i2;

   mult = pow (2.0, 1.0 / 12.0);
   f1 = 7902133.0;

   printf ("// musical-notes.h\n");
   printf ("\n");
   printf ("typedef enum musical_notes {\n");

   for (i1 = 5; i1 >= 0; i1--) {
      for (i2 = 0; i2 < 12; i2++) {
         if (strlen (note[i2]) > 1) {
            print_note (0, note[i2 + 12], i1, f1);
         }
         print_note (0, note[i2], i1, f1);
         f1 /= mult;
      }
      printf ("\n");
   }
   for (i1 = 0; i1 <= 2; i1++) {
      printf ("\n");
      for (i2 = 0; i2 < 12; i2++) {
         if (strlen (note[i2]) > 1) {
            print_note (1, note[i2 + 12], i1, f1);
         }
         print_note (1, note[i2], i1, f1);
         f1 /= mult;
      }
   }
   printf ("} musical_notes;\n");
   printf ("\n");
   return 0;
}

