// crc-stm32.c

#include <errno.h>
#include <libgen.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "srecord.h"
#include "fail.h"
#include "../include/image-header.h"

static uint32_t  dbuf[32];


static uint32_t
crc_stm32 (uint32_t crc, uint32_t data)
{
   int i1;

   crc = crc ^ data;

   for (i1 = 0; i1 < 32; i1++) {
      if (crc & 0x80000000) {
         crc = (crc << 1) ^ 0x04C11DB7; // Polynomial used in STM32
      } else {
         crc = (crc << 1);
      }
   }
   return crc;
}


int
main (int argc, char *argv[])
{
   uint32_t crc;
   int      i1;

   for (i1 = 0; i1 < 32; i1 += 4) {
      dbuf[i1 / 4] = 0xffffffff;
   }
   crc = 0xffffffff;
   for (i1 = 0; i1 < 32; i1 += 4) {
      crc = crc_stm32 (crc, dbuf[i1 / 4]);
   }
   printf ("%08x\n", crc);
   return 0;
}

