// gsm-print.c

#include <errno.h>
#include <stdint.h>
#include <stdio.h>
#include "fail.h"
#include "srecord.h"


void
gsm_print (img_st *image, int i_size, const char *file)
{
   FILE     *gsm;
   int       ads;
   int       i1, i2, checksum, bpl = 256;
   uint32_t  word;

   ads = image->hw_ads & image->imask;

   printf ("gsm_print: %s: %d bytes at 0x%x\n",
           image->comment, i_size, image->hw_ads);
   if (i_size < 4) { return; }

   gsm = fail_or_create (file);

   for (i2 = 0; i2 < i_size; i2 += bpl) {
      checksum = 0;
      for (i1 = 0; i1 < bpl; i1++) {
         checksum += * (image->data + ads++);
      }
      if (checksum == bpl * 255) { continue; }
      ads -= bpl;
      //  crc = crcbitbybitfast (image, ads, ads - 1, ads + bpl);

      for (i1 = 0; i1 < bpl / 4; i1++) {
         word  = (uint32_t)image->data[ads++] <<  0;
         word |= (uint32_t)image->data[ads++] <<  8;
         word |= (uint32_t)image->data[ads++] << 16;
         word |= (uint32_t)image->data[ads++] << 24;
         if ((int)word > -99999999) {
            fprintf (gsm, "%d\n", (int)word);
         } else {
            fprintf (gsm, "%u\n", word);
         }
      }
      //  fprintf (gsm, "%u\n", crc);
      fprintf (gsm, "\n");
   }
   fclose (gsm);
   return;
}

