// crc.c

#include <stdint.h>
#include "F205/crc.h"
#include "F205/rcc.h"
#include "asm.h"
#include "image-header.h"


int
crc_check (image_struct *region)
{
   uint32_t  *p;

//if ((uint32_t)region != (uint32_t)region->self)  return -1;
//if (region->magic != CRC_MAGIC)  return -1;
//if (region->crt1 != 0 && region->crt1 < p || region->crt1 >= region->end)

   RCC->AHB1ENR |= 1 << AHB1_CRC;
   DSB ();
   p = (uint32_t *)region;
   CRC->CR_RESET = 1;

   while (p < &region->crc) {
      CRC->DR = *p++;
   }
   p += 1;
   while (p < (uint32_t *)region->end) {
      CRC->DR = *p++;
   }
   if (CRC->DR != region->crc) {
      return -1;
   }
   return 0;
}

