// uart6.c

#include <stddef.h>
#include "asm.h"
#include "F205/rcc.h"
#include "F205/uart.h"


int
getchar6 (void)
{
   if (UART6->SR_RXNE == 0) { return 0; }
   return UART6->DR;
}


int
putchar6 (int c1)
{
   if (c1 == '\n') {
      return putchar6 ('\r');
   }
   while (UART6->SR_TXE == 0) {  }
   UART6->DR = c1;
   return c1;
}


int
puts6 (const char *text)
{
   while (*text) {
      putchar6 (*text++);
   }
   putchar6 ('\r');
   return 0;
}


void
uart6_init (int baud)
{
   static const int  br_clock = 16000000;
   uart_struct      *uart;

   RCC->APB2RSTR |= (1 << APB2_USART6);
   uart = UART6;
   ISB ();
   DSB ();
   RCC->APB2RSTR &= ~ (1 << APB2_USART6);

// br_clock ist genau genommen = (clocks->apbx / 16) * 16
// wegen 16 Clocks/Bit und 4 Bit fractional baud rate
   uart->BRR = (br_clock + baud / 2) / baud;

   uart->CR2_STOP2 = 1;
   uart->CR1_TE = 1;
   uart->CR1_RE = 1;
   uart->CR1_UE = 1;
   return;
}

